import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import { useState } from "react";
export default function useFormValidation() {
  var initialValue = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var options = arguments.length > 1 ? arguments[1] : undefined;

  var _useState = useState(initialValue),
      _useState2 = _slicedToArray(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  var _useState3 = useState([]),
      _useState4 = _slicedToArray(_useState3, 2),
      errors = _useState4[0],
      setErrors = _useState4[1];

  var _useState5 = useState(false),
      _useState6 = _slicedToArray(_useState5, 2),
      dirty = _useState6[0],
      setDirty = _useState6[1];

  var _useState7 = useState(false),
      _useState8 = _slicedToArray(_useState7, 2),
      isValid = _useState8[0],
      setIsValid = _useState8[1];

  function validateEmail(email) {
    var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(String(email).toLowerCase());
  } 

  function checkForErrors(value) {
    var newErrors = [];

    if (options.minLength && value.length < options.minLength) {
      newErrors.push("You need a minimum of ".concat(options.minLength, " characters"));
    }

    if (options.maxLength && value.length > options.maxLength) {
      newErrors.push("You have exceeded the max characters of ".concat(options.maxLength));
    }

    if (options.required && value.length === 0) {
      newErrors.push("This field is required");
    }

    if (options.email && !validateEmail(value)) {
      newErrors.push("Please enter a valid email");
    }

    setErrors(newErrors);
    setIsValid(newErrors.length === 0 ? true : false);
  }

  function onChangeHandler(event) {
    var value = event.target.value;
    setValue(value);

    if (dirty) {
      checkForErrors(value);
    }
  }

  function onBlurHandler() {
    setDirty(true);
    checkForErrors(value);
  }

  return [errors, {
    value: value,
    onBlur: onBlurHandler,
    onChange: onChangeHandler
  }, isValid];
}